
electronique_gradateur_012_12f675_Main_Init:
;electronique_gradateur_012_12f675.mpas,9 :: 		begin
;electronique_gradateur_012_12f675.mpas,10 :: 		INTCON.GIE  := 1;  // enable global interrupts;
	BSF        INTCON+0, 7
;electronique_gradateur_012_12f675.mpas,11 :: 		INTCON.PEIE := 0;  // disable peripheral int
	BCF        INTCON+0, 6
;electronique_gradateur_012_12f675.mpas,12 :: 		INTCON.T0IE := 0;  // disable Timer0 int
	BCF        INTCON+0, 5
;electronique_gradateur_012_12f675.mpas,13 :: 		INTCON.INTE := 0;  // disable GP2/INT int
	BCF        INTCON+0, 4
;electronique_gradateur_012_12f675.mpas,14 :: 		INTCON.GPIE := 0;  // disable GPIO int
	BCF        INTCON+0, 3
;electronique_gradateur_012_12f675.mpas,15 :: 		INTCON.GPIF := 0;  // reset GPIO int flag
	BCF        INTCON+0, 0
;electronique_gradateur_012_12f675.mpas,17 :: 		IOC         := 0;  // disable Interrupt On Change
	CLRF       IOC+0
;electronique_gradateur_012_12f675.mpas,18 :: 		T1CON       := %00000001;
	MOVLW      1
	MOVWF      T1CON+0
;electronique_gradateur_012_12f675.mpas,20 :: 		OPTION_REG.NOT_GPPU := 1;  // disable pull-up
	BSF        OPTION_REG+0, 7
;electronique_gradateur_012_12f675.mpas,21 :: 		WPU := 0;                  // disable pull-up
	CLRF       WPU+0
;electronique_gradateur_012_12f675.mpas,23 :: 		TRISIO := %00001001;   // all output, but GP0/AN0
	MOVLW      9
	MOVWF      TRISIO+0
;electronique_gradateur_012_12f675.mpas,24 :: 		GPIO   := %00000000;   // set all outputs to low state (GPIO3 read as 1)
	CLRF       GPIO+0
;electronique_gradateur_012_12f675.mpas,26 :: 		CMCON := %00000111;   // comparators OFF (CMCON = 7)
	MOVLW      7
	MOVWF      CMCON+0
;electronique_gradateur_012_12f675.mpas,32 :: 		ADCON0.ADON  := 1;     // turn on ADC module
	BSF        ADCON0+0, 0
;electronique_gradateur_012_12f675.mpas,33 :: 		ADCON0.VCFG  := 0;     // voltage ref = VDD
	BCF        ADCON0+0, 6
;electronique_gradateur_012_12f675.mpas,34 :: 		ADCON0.ADFM  := 1;     // 0 = left justified, 1 = right justified
	BSF        ADCON0+0, 7
;electronique_gradateur_012_12f675.mpas,35 :: 		ADCON0.ADCS2 := 0;     //  0|
	BCF        ADCON0+0, 6
;electronique_gradateur_012_12f675.mpas,36 :: 		ADCON0.ADCS1 := 0;     //  0| Fosc/8 / 2 us / 4 MHz
	BCF        ADCON0+0, 5
;electronique_gradateur_012_12f675.mpas,37 :: 		ADCON0.ADCS0 := 1;     //  1|
	BSF        ADCON0+0, 4
;electronique_gradateur_012_12f675.mpas,38 :: 		ANSEL.ANS0   := 1;     // set GP0 as analog input
	BSF        ANSEL+0, 0
;electronique_gradateur_012_12f675.mpas,39 :: 		ANSEL.ANS1   := 0;     // set GP1 as digital I/O
	BCF        ANSEL+0, 1
;electronique_gradateur_012_12f675.mpas,40 :: 		ANSEL.ANS2   := 0;     // set GP2 as digital I/O
	BCF        ANSEL+0, 2
;electronique_gradateur_012_12f675.mpas,41 :: 		ANSEL.ANS3   := 0;     // set GP4 as digital I/O
	BCF        ANSEL+0, 3
;electronique_gradateur_012_12f675.mpas,43 :: 		AdcInOld := 0;
	CLRF       _AdcInOld+0
	CLRF       _AdcInOld+1
;electronique_gradateur_012_12f675.mpas,44 :: 		iStepADC := 50;
	MOVLW      50
	MOVWF      _iStepADC+0
;electronique_gradateur_012_12f675.mpas,45 :: 		PwmDuty := 0;
	CLRF       _PwmDuty+0
;electronique_gradateur_012_12f675.mpas,47 :: 		end;
	RETURN
; end of electronique_gradateur_012_12f675_Main_Init

_main:
;electronique_gradateur_012_12f675.mpas,50 :: 		begin
;electronique_gradateur_012_12f675.mpas,51 :: 		Main_Init;
	CALL       electronique_gradateur_012_12f675_Main_Init+0
;electronique_gradateur_012_12f675.mpas,53 :: 		while true do
L__main3:
;electronique_gradateur_012_12f675.mpas,57 :: 		if iStepADC >= 50 then
	MOVLW      50
	SUBWF      _iStepADC+0, 0
	BTFSS      STATUS+0, 0
	GOTO       L__main8
;electronique_gradateur_012_12f675.mpas,59 :: 		iStepADC := 0;
	CLRF       _iStepADC+0
;electronique_gradateur_012_12f675.mpas,61 :: 		AdcInNew := word(ADC_Read(0));  // ADC 10 bits, read all 10 bits
	CLRF       FARG_Adc_Read_channel+0
	CALL       _Adc_Read+0
	MOVF       R0+0, 0
	MOVWF      _AdcInNew+0
	MOVF       R0+1, 0
	MOVWF      _AdcInNew+1
;electronique_gradateur_012_12f675.mpas,63 :: 		if AdcInNew <> AdcInOld then
	MOVF       R0+1, 0
	XORWF      _AdcInOld+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__main16
	MOVF       _AdcInOld+0, 0
	XORWF      R0+0, 0
L__main16:
	BTFSC      STATUS+0, 2
	GOTO       L__main11
;electronique_gradateur_012_12f675.mpas,65 :: 		PwmDuty := byte(AdcInNew / 10.2);
	MOVF       _AdcInNew+0, 0
	MOVWF      R0+0
	MOVF       _AdcInNew+1, 0
	MOVWF      R0+1
	CALL       _Word2Double+0
	MOVLW      51
	MOVWF      R4+0
	MOVLW      51
	MOVWF      R4+1
	MOVLW      35
	MOVWF      R4+2
	MOVLW      130
	MOVWF      R4+3
	CALL       _Div_32x32_FP+0
	CALL       _Double2Byte+0
	MOVF       R0+0, 0
	MOVWF      _PwmDuty+0
;electronique_gradateur_012_12f675.mpas,66 :: 		AdcInOld := AdcInNew;
	MOVF       _AdcInNew+0, 0
	MOVWF      _AdcInOld+0
	MOVF       _AdcInNew+1, 0
	MOVWF      _AdcInOld+1
;electronique_gradateur_012_12f675.mpas,67 :: 		end;
L__main11:
;electronique_gradateur_012_12f675.mpas,68 :: 		end
	GOTO       L__main9
;electronique_gradateur_012_12f675.mpas,69 :: 		else
L__main8:
;electronique_gradateur_012_12f675.mpas,71 :: 		inc(iStepADC);
	INCF       _iStepADC+0, 1
;electronique_gradateur_012_12f675.mpas,72 :: 		end;
L__main9:
;electronique_gradateur_012_12f675.mpas,75 :: 		if iStepPWM < 100 then
	MOVLW      100
	SUBWF      _iStepPWM+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L__main14
;electronique_gradateur_012_12f675.mpas,76 :: 		inc(iStepPWM)
	INCF       _iStepPWM+0, 1
	GOTO       L__main15
;electronique_gradateur_012_12f675.mpas,77 :: 		else
L__main14:
;electronique_gradateur_012_12f675.mpas,78 :: 		iStepPWM := 0;
	CLRF       _iStepPWM+0
L__main15:
;electronique_gradateur_012_12f675.mpas,79 :: 		GPIO.1 := (PwmDuty > iStepPWM);
	MOVF       _PwmDuty+0, 0
	SUBWF      _iStepPWM+0, 0
	MOVLW      255
	BTFSC      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	BTFSC      R0+0, 0
	GOTO       L__main17
	BCF        GPIO+0, 1
	GOTO       L__main18
L__main17:
	BSF        GPIO+0, 1
L__main18:
;electronique_gradateur_012_12f675.mpas,81 :: 		end;
	GOTO       L__main3
;electronique_gradateur_012_12f675.mpas,82 :: 		end.
	GOTO       $+0
; end of _main
